//---------------------------------------------------------------------------
// MixDir() is in global.cpp
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixmastDlg.h"
#include "Global.h"
#include "Wiper.h"
#include "Mixmaster.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMixForm *MixForm;
//---------------------------------------------------------------------------
/*
AnsiString __fastcall MixDir()
{
   TIniFile *ini = new TIniFile(AppIni);
   AnsiString mixdir = ini->ReadString("main","mixpath","");
   delete ini;
   if ( mixdir.IsEmpty()) mixdir = getenv("MIXPATH");
   if (!mixdir.IsEmpty() && mixdir[mixdir.Length()]!='\\') mixdir += "\\";
   return mixdir.LowerCase();
}
*/
//---------------------------------------------------------------------------
int __fastcall data_encrypt(char **data, long &datlen, char *password, int paslen)
{
   int result;
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   buf_append(pas,(byte*)password,paslen);
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_encrypt(PGP_CONVENTIONAL|PGP_NOARMOR,dat,pas,NULL,NULL,NULL,NULL))==0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy uncompressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(pas); buf_free(dat);
   return result;
}
//---------------------------------------------------------------------------
int __fastcall data_decrypt(char **data, long &datlen, char *password, int paslen)
{
   int result;
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   buf_append(pas,(byte*)password,paslen);
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_decrypt(dat,pas,NULL,NULL,NULL))==0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy uncompressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(pas); buf_free(dat);
   return result;
}
//---------------------------------------------------------------------------
int __fastcall data_compress(char **data, long &datlen)
{
   int result;
   BUFFER *dat = buf_new(); dat->sensitive = true;
   // put data in buffer
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_encrypt(PGP_NOARMOR,dat,NULL,NULL,NULL,NULL,NULL)) == 0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy compressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(dat);
   return result;
}
//---------------------------------------------------------------------------
int __fastcall data_uncompress(char **data, long &datlen)
{
   int result;
   BUFFER *dat = buf_new(); dat->sensitive = true;
   // put compressed data in buffer
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_decrypt(dat,NULL,NULL,NULL,NULL)) == 0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy uncompressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(dat);
   return result;
}
//---------------------------------------------------------------------------
int __fastcall PgpSignMessage(TStringList *Msg, TDataBuf *Password, const AnsiString &SigId,
   const AnsiString &SKeyRing)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...signing message...";
   MixForm->SigId = SigId;
   MixForm->SKeyRing = SKeyRing;
   MixForm->Message->Text = Msg->Text;
   MixForm->Mode = modePgpSignMessage;
   MixForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   MixForm->Password = Password; MixForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = MixForm->Message->Text;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptMessage(TStringList *Msg, TStringList *Recips,const AnsiString &PKeyRing)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...encrypting message...";
   MixForm->Recips = Recips;
   MixForm->PKeyRing = PKeyRing;
   MixForm->Message->Text = Msg->Text;
   MixForm->Mode = modePgpEncryptMessage;
   MixForm->Caption = "Pgp";
   MixForm->ShowModal();
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = MixForm->Message->Text;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptConventional(TStringList *Msg, TDataBuf *Passphrase)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...encrypting message...";
   MixForm->Message->Text = Msg->Text;
   MixForm->Mode = modePgpEncryptConventional;
   MixForm->Caption = "Pgp";
   Passphrase->Decrypt(BUFWORD);
   MixForm->Password = Passphrase; MixForm->ShowModal();
   Passphrase->Encrypt(BUFWORD);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = MixForm->Message->Text;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptSignMessage(TStringList *Msg, TStringList *Recips, const AnsiString &SigId,
   TDataBuf *Password, const AnsiString &PKeyRing, const AnsiString &SKeyRing)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...encrypt/signing...";
   MixForm->SigId = SigId;
   MixForm->Recips = Recips;
   MixForm->PKeyRing = PKeyRing;
   MixForm->SKeyRing = SKeyRing;
   MixForm->Message->Text = Msg->Text;
   MixForm->Mode = modePgpEncryptSignMessage;
   MixForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   MixForm->Password = Password; MixForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = MixForm->Message->Text;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptFile(TDataBuf *Password, AnsiString &Filename, AnsiString &Ext)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...encrypting "+ExtractFileName(AppDat.LowerCase())+"...";
   MixForm->Filename = Filename;//.LowerCase();
   MixForm->NewExt = Ext;
   MixForm->Mode = modePgpEncryptFile;
   MixForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   MixForm->Password = Password; MixForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpDecryptFile(TDataBuf *Password, AnsiString &Filename, AnsiString &Ext)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...decrypting "+ExtractFileName(AppPgp.LowerCase())+"...";
   MixForm->Filename = Filename;//.LowerCase();
   MixForm->NewExt = Ext;
   MixForm->Mode = modePgpDecryptFile;
   MixForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   MixForm->Password = Password;
   MixForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall MixConfigNym(TDataBuf *Password, TStrings *message, TComponent *Owner)
{
   MixForm = new TMixForm(Owner);
   MixForm->Cap = "  Encrypting Nym Config...";
   MixForm->Message = message;
   MixForm->Mode = modeMixConfigNym;
   MixForm->Caption = "Mixmaster";
   Password->Decrypt(BUFWORD);
   MixForm->Password = Password; MixForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
__fastcall TMixForm::TMixForm(TComponent* Owner)
  : TForm(Owner)
{
   Position = poScreenCenter;
   if (Application->MainForm)
   {
      Position = poDesigned;
      TForm *Main = Application->MainForm;
      Top = Main->Top+((Main->Height-Height)/2);
      Left = Main->Left+((Main->Width-Width)/2);
   }
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
   Message = new TStringList();
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::FormDestroy(TObject *Sender)
{
   delete Message;
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   switch (Mode)
   {
      case modePgpEncryptFile:
      {
         AnsiString pgpname = ChangeFileExt(Filename,PgpExt);
         if (ModalResult==mrCancel && FileExists(pgpname))
            remove(pgpname.c_str());
         break;
      }
      case modePgpDecryptFile:
      {
         AnsiString datname = ChangeFileExt(Filename,DatExt);
         if (ModalResult==mrCancel && FileExists(datname))
            remove(datname.c_str());
         break;
      }
   }
   Sleep(500);
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpSignMessage()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = pas->sensitive = true;
   Application->ProcessMessages();
   buf_append(pas,(byte*)Password->data,Password->length);
   buf_append(dat,(byte*)Message->Text.c_str(),Message->Text.Length());
   Result = pgp_mailenc(PGP_SIGN,dat,SigId.c_str(),pas,NULL,SKeyRing.c_str());
   switch (Result)
   {
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","Sign Error",MB_OK); break;
      case  0: Message->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP signing error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpEncryptConventional()
{
   BUFFER *dat = buf_new(), *enc = buf_new();
   dat->sensitive = true; enc->sensitive = true;
   Application->ProcessMessages();
   buf_append(enc,(byte*)Password->data,Password->length);
   buf_append(dat,(byte*)Message->Text.c_str(),Message->Text.Length());
   Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_TEXT,dat,enc,NULL,NULL,PKeyRing.c_str(),NULL);
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: Message->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(enc); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpEncryptMessage()
{
   BUFFER *dat = buf_new(), *enc = buf_new();
   dat->sensitive = true; enc->sensitive = true;
   Application->ProcessMessages();
   buf_append(enc,(byte*)Recips->Text.c_str(),Recips->Text.Length());
   buf_append(dat,(byte*)Message->Text.c_str(),Message->Text.Length());
   Result = pgp_encrypt(PGP_ENCRYPT|PGP_TEXT,dat,enc,NULL,NULL,PKeyRing.c_str(),NULL);
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: Message->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(enc); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpEncryptSignMessage()
{
   BUFFER *dat = buf_new(), *enc = buf_new(), *sig = buf_new(), *pas = buf_new();
   dat->sensitive = enc->sensitive = sig->sensitive = pas->sensitive = true;
   Application->ProcessMessages();
   buf_append(enc,(byte*)Recips->Text.c_str(),Recips->Text.Length());
   buf_append(dat,(byte*)Message->Text.c_str(),Message->Text.Length());
   buf_append(sig,(byte*)SigId.c_str(),SigId.Length());
   buf_append(pas,(byte*)Password->data,Password->length);
   Result = pgp_encrypt(PGP_SIGN|PGP_ENCRYPT|PGP_TEXT,dat,enc,sig,pas,
      PKeyRing.c_str(),SKeyRing.c_str());
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: Message->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt/sign error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(pas); buf_free(sig); buf_free(enc); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpEncryptFile()
{
   BUFFER *dat = buf_new(), *pas = buf_new(), *enc = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
   Password->Decrypt(BUFWORD);
   buf_append(pas,(byte*)Password->data,Password->length);
   Password->Encrypt(BUFWORD);
   buf_readfile(dat,Filename.c_str());
   Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_NOARMOR,dat,pas,NULL,enc,NULL,NULL);
   if (!Result) buf_writefile(dat,ChangeFileExt(Filename,NewExt).c_str(),"wb");

   Application->ProcessMessages();
   buf_free(enc); buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpDecryptFile()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
   Password->Decrypt(BUFWORD);
   buf_append(pas,(byte*)Password->data,Password->length);
   Password->Encrypt(BUFWORD);
   buf_readfile(dat,Filename.c_str());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (!Result) buf_writefile(dat,ChangeFileExt(Filename,NewExt).c_str(),"wb");

   Application->ProcessMessages();
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::MixEncryptNymCnfg()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
   Password->Decrypt(BUFWORD);
   buf_append(pas,(byte*)Password->data,Password->length);
   Password->Encrypt(BUFWORD);
   buf_readfile(dat,Filename.c_str());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (!Result) buf_writefile(dat,ChangeFileExt(Filename,NewExt).c_str(),"wb");

   Application->ProcessMessages();
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Label1->Caption = Cap;
   switch (Mode)
   {
      case modePgpEncryptFile: PgpEncryptFile(); break;
      case modePgpDecryptFile: PgpDecryptFile(); break;
      case modePgpSignMessage: PgpSignMessage(); break;
      case modePgpEncryptMessage: PgpEncryptMessage(); break;
      case modePgpEncryptSignMessage: PgpEncryptSignMessage(); break;
      case modePgpEncryptConventional: PgpEncryptConventional(); break;
   }
   Application->ProcessMessages();
   if (ModalResult == mrNone)
       ModalResult = mrOk;
 }
//---------------------------------------------------------------------------
void __fastcall TMixForm::Timer2Timer(TObject *Sender)
{
   if (Label1->Caption.IsEmpty()) Label1->Caption = Cap;
   else Label1->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::Timer3Timer(TObject *Sender)
{
   ProgressBar->Position += (WORD)1;
   if (*Cancelled && ProgressBar->Position<100)
   {
      int start = ProgressBar->Position;
      for (int i=start; i<=100; i++)
      {
         ProgressBar->Position += (WORD)1;
         Application->ProcessMessages();
         Sleep(1);
      }
      Timer3->Enabled = false;
      ModalResult = mrCancel;
   }
}
//---------------------------------------------------------------------------




