//---------------------------------------------------------------------------
#ifndef MsgInWinH
#define MsgInWinH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>

#include "NoteWin.h"
#include "HeadMan.h"
//---------------------------------------------------------------------------
bool __fastcall OpenMessageIn(AnsiString &MailBox, AnsiString &IndexStr);

class TMessageInWin : public TTextWin
{
__published:	// IDE-managed Components
  TSpeedButton *ReplyBtn;
  TSpeedButton *HeadersBtn;
  TCheckBox *WordWrap;
  TSpeedButton *EditBtn;
  TCheckBox *NoHeaders;
  void __fastcall HeadersBtnClick(TObject *Sender);
  void __fastcall ReplyBtnClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall WordWrapClick(TObject *Sender);
  void __fastcall EditBtnClick(TObject *Sender);
  void __fastcall NoHeadersClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   bool FullHeaders;
   THeaderManager *Headers;
   AnsiString Mailbox,IndexStr;
   virtual __fastcall TMessageInWin(TComponent* Owner);
   virtual __fastcall TMessageInWin(AnsiString &MailBox, AnsiString &Indexstr,
      TComponent *Owner);
   virtual __fastcall ~TMessageInWin();
   void __fastcall SetMessage();
   void __fastcall SetEditMode(bool Editing);
   void __fastcall CreateReply(bool UseDialog);
   bool __fastcall CheckSave();
   bool __fastcall Save();
};
//---------------------------------------------------------------------------
extern TMessageInWin *MessageInWin;
//---------------------------------------------------------------------------
#endif
