//---------------------------------------------------------------------------
#ifndef PopAccDlgH
#define PopAccDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "Pop3Prot.hpp"
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
class TPopAcctDlg : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TButton *NewBtn;
  TButton *EditBtn;
  TButton *DeleteBtn;
  TButton *OkBtn;
  TButton *CancelBtn;
  TPanel *Panel2;
  THeaderControl *HeaderControl1;
  TListBox *Accts;
  TPopupMenu *PopupMenu;
  TMenuItem *PopGetMailItem;
  TMenuItem *PopGetThisItem;
  TMenuItem *PopToggleItem;
  TMenuItem *N1;
  TSpeedButton *AcctUp;
  TSpeedButton *AcctDn;
  TLabel *Label1;
  void __fastcall AcctsDrawItem(TWinControl *Control, int Index, TRect &Rect,
     TOwnerDrawState State);
  void __fastcall HeaderControl1DrawSection(THeaderControl *HeaderControl,
     THeaderSection *Section, const TRect &Rect, bool Pressed);
  void __fastcall AcctsMouseDown(TObject *Sender, TMouseButton Button,
     TShiftState Shift, int X, int Y);
  void __fastcall AcctsKeyPress(TObject *Sender, char &Key);
  void __fastcall HeaderControl1SectionClick(THeaderControl *HeaderControl,
     THeaderSection *Section);
  void __fastcall NewBtnClick(TObject *Sender);
  void __fastcall EditBtnClick(TObject *Sender);
  void __fastcall AcctsClick(TObject *Sender);
  void __fastcall DeleteBtnClick(TObject *Sender);
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall PopupMenuPopup(TObject *Sender);
  void __fastcall PopToggleItemClick(TObject *Sender);
  void __fastcall AcctDnClick(TObject *Sender);
  void __fastcall AcctUpClick(TObject *Sender);
  void __fastcall AcctsDblClick(TObject *Sender);
  void __fastcall PopGetThisItemClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:	// User declarations
public:		// User declarations
  RECT r;
  int index;
  TPoint mouse;
  TStrings *accts;
  TStringList *acct;
  long LastItem;
  TPoint LastMouse;
  TForm *MainForm;
  bool modified;
  __fastcall TPopAcctDlg(TComponent* Owner);
  __fastcall virtual ~TPopAcctDlg();
  bool __fastcall Checked();
  AnsiString __fastcall Password(); // account password
  AnsiString __fastcall Account();
  int  __fastcall CheckCount();
  void __fastcall SyncAccts();
  bool __fastcall Remember();
  bool __fastcall Delete();
  bool __fastcall PgpOnly();
  void __fastcall LoadAcct(int Index);
  void __fastcall SaveAcct();
  void __fastcall DrawCheck(TCanvas *Canvas, TRect &Rect, TColor Color);
  void __fastcall AcctsDrawItemCanvas(TCanvas *Canvas, int Index, TRect &Rect,
     TOwnerDrawState State);
};
//---------------------------------------------------------------------------
extern TPopAcctDlg *PopAcctDlg;
//---------------------------------------------------------------------------
#endif
