# ---------------------------------------------------------------------------
VERSION = BCB.01
# ---------------------------------------------------------------------------
!ifndef BCB
BCB = $(MAKEDIR)\..
!endif
# ---------------------------------------------------------------------------
PROJECT = QS.exe
OBJFILES = QS.obj MainMDI.obj NoteWin.obj FileWin.obj RptWin.obj MsgWin.obj \
   PackDlg.obj PrintDlg.obj SmtpDlg.obj AddrsDlg.obj QueueDlg.obj OpenDlg.obj \
   Wiper.obj AboutDlg.obj SaveDlg.obj GetStrtDlg.obj WaitDlg.obj PreferDlg.obj \
   DelGrpsDlg.obj MimeMan.obj Version.obj Global.obj HeadMan.obj Console.obj \
   ClipReply.obj FileMan.obj Fmxutils.obj DirBrow.obj HttpDlg.obj UrlsDlg.obj \
   PicBoxDlg.obj MailDlg.obj NNameDlg.obj MBoxWin.obj PassDlg.obj PgpPass.obj \
   PgpRecip.obj MixmastDlg.obj MixInstDlg.obj Mixmaster.obj MixMsg.obj \
   pop3mail.obj MsgInWin.obj UPDUnzipDlg.obj UPDateDlg.obj UPDedDlg.obj \
   UPDFtpDlg.obj
RESFILES = QS.res
RESDEPEN = $(RESFILES) MainMDI.dfm NoteWin.dfm FileWin.dfm RptWin.dfm \
   MsgWin.dfm PackDlg.dfm PrintDlg.dfm SmtpDlg.dfm AddrsDlg.dfm QueueDlg.dfm \
   OpenDlg.dfm Wiper.dfm AboutDlg.dfm SaveDlg.dfm GetStrtDlg.dfm WaitDlg.dfm \
   PreferDlg.dfm DelGrpsDlg.dfm ClipReply.dfm DirBrow.dfm HttpDlg.dfm UrlsDlg.dfm \
   PicBoxDlg.dfm MailDlg.dfm NNameDlg.dfm MBoxWin.dfm PassDlg.dfm PgpPass.dfm \
   PgpRecip.dfm MixmastDlg.dfm MixInstDlg.dfm MsgInWin.dfm UPDUnzipDlg.dfm \
   UPDateDlg.dfm UPDedDlg.dfm UPDFtpDlg.dfm
LIBFILES = zlib.LIB
DEFFILE =
# ---------------------------------------------------------------------------
CFLAG1 = -Od -Hc -w -k -r- -y -v -vi- -c -a4 -b- -w-par -w-inl -Vx -Ve -x
CFLAG2 = -I.;$(BCB)\lib\ics\delphi\vc32;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\listbox \
   -H=$(BCB)\lib\vcld.csm 
PFLAGS = -U.;$(BCB)\lib\ics\delphi\vc32;$(BCB)\lib\obj;$(BCB)\lib;$(BCB)\lib\listbox \
   -I.;$(BCB)\lib\ics\delphi\vc32;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\listbox \
   -AWinTypes=Windows;WinProcs=Windows;DbiTypes=BDE;DbiProcs=BDE;DbiErrs=BDE -W \
   -v -$Y -$W -$O- -JPHNV -M
RFLAGS = -i.;$(BCB)\lib\ics\delphi\vc32;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\listbox 
LFLAGS = -L.;$(BCB)\lib\ics\delphi\vc32;$(BCB)\lib\obj;$(BCB)\lib;$(BCB)\lib\listbox \
   -aa -Tpe -x -v -V4.0
IFLAGS =
LINKER = ilink32
# ---------------------------------------------------------------------------
ALLOBJ = c0w32.obj $(OBJFILES)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) vcl.lib import32.lib cp32mt.lib
# ---------------------------------------------------------------------------
.autodepend

$(PROJECT): $(OBJFILES) $(RESDEPEN) $(DEFFILE)
    $(BCB)\BIN\$(LINKER) @&&!
    $(LFLAGS) +
    $(ALLOBJ), +
    $(PROJECT),, +
    $(ALLLIB), +
    $(DEFFILE), +
    $(ALLRES)
!

.pas.hpp:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.pas.obj:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.cpp.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $*

.c.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $**

.rc.res:
    $(BCB)\BIN\brcc32 $(RFLAGS) $<
#-----------------------------------------------------------------------------

