//---------------------------------------------------------------------------
#ifndef RelEditDlgH
#define RelEditDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
void __fastcall EditFileList();

class TFileListDlg : public TForm
{
__published:	// IDE-managed Components
  TListBox *ListBox;
  TButton *CancelBtn;
  TButton *OkBtn;
  TCheckBox *FilterBox;
  void __fastcall ListBoxClick(TObject *Sender);
  void __fastcall ListBoxDblClick(TObject *Sender);
  void __fastcall FilterBoxClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall FormShow(TObject *Sender);
private:	// User declarations
public:		// User declarations
   TStringList *files;
  __fastcall TFileListDlg(TComponent* Owner);
  void __fastcall GetFileNames(bool filter);
};
//---------------------------------------------------------------------------
extern TFileListDlg *FileListDlg;
//---------------------------------------------------------------------------
#endif
