//---------------------------------------------------------------------------
#ifndef ReleaseUH
#define ReleaseUH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
class TIniForm : public TForm
{
__published:	// IDE-managed Components
  TButton *CancelBtn;
  TButton *NextBtn;
  TButton *BackBtn;
  TBevel *Bevel1;
  TPageControl *PageControl1;
  TTabSheet *CreateIni;
  TMemo *IniStore;
  TLabel *Label1;
  TMemo *Memo2;
  TButton *StoreBtn;
  TTabSheet *Start;
  TLabel *Label3;
  TTabSheet *CopyFiles;
  TEdit *AppMak;
  TLabel *Label4;
  TButton *BrowAppBtn;
  TOpenDialog *OpenDialog1;
  TTimer *Timer1;
  TMemo *AppFiles;
  TLabel *Label6;
  TButton *CopyFilesBtn;
  TButton *Button1;
  TTabSheet *TabSheet1;
  TMemo *CompExes;
  TLabel *Label7;
  TButton *Button2;
  TButton *PackBtn;
  TMemo *Copied;
  TLabel *Label8;
  TMemo *Comped;
  TLabel *Label10;
  TLabel *Label5;
  TEdit *DestDir;
  TButton *BrowDestBtn;
  TEdit *Aspack;
  TButton *BrowAspackBtn;
  TLabel *Label11;
  TEdit *AppName1;
  TEdit *AppVer;
  TEdit *AppSubVer;
  TUpDown *UpDown1;
  TLabel *Label13;
  TLabel *Label14;
  TTabSheet *TabSheet2;
  TCheckBox *ZipAllBox;
  TCheckBox *ZipRelBox;
  TButton *ZipperBtn;
  TMemo *Memo3;
  TButton *ShowRelDir;
  TEdit *ZipFull;
  TEdit *ZipRel;
  TLabel *Label12;
  TEdit *ArcPath;
  TButton *Button3;
  TTabSheet *TabSheet3;
  TEdit *Version;
  TLabel *Label2;
  TTabSheet *TabSheet4;
  TMemo *CompProj;
  TMemo *Memo5;
  TButton *CompileBtn;
  TLabel *Label15;
  TLabel *Label16;
  TEdit *MakePro;
  TLabel *Label17;
  TButton *BrowseMakeBtn;
  TButton *ShowAppDirBtn;
  TButton *BrowVersionHBtn;
  TSpeedButton *OpenVersionHBtn;
  TSpeedButton *OpenMakBtn;
  TEdit *SelfExt;
  TLabel *Label9;
  TButton *Button4;
  TButton *CreateSEBtn;
  TMemo *Memo1;
  TEdit *SEinput;
  TSpeedButton *SEinputBtn;
  TLabel *Label18;
  TEdit *SEmsg;
  TSpeedButton *SpeedButton1;
  TLabel *Label19;
  TButton *FListBtn;
  TEdit *SEabout;
  TSpeedButton *SpeedButton2;
  TLabel *Label20;
  TTabSheet *TabSheet5;
  TButton *HistoryBtn;
  TButton *ReadmeBtn;
  TButton *LicenseBtn;
  TButton *TodoBtn;
  TButton *QuickstartBtn;
  TEdit *History;
  TEdit *Readme;
  TEdit *License;
  TEdit *Todo;
  TEdit *Quickstart;
  void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall NextBtnClick(TObject *Sender);
  void __fastcall BackBtnClick(TObject *Sender);
  void __fastcall StoreBtnClick(TObject *Sender);
  void __fastcall PageControl1Change(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall BrowAppBtnClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall CopyFilesBtnClick(TObject *Sender);
  void __fastcall Button1Click(TObject *Sender);
  void __fastcall PackBtnClick(TObject *Sender);
  void __fastcall Button3Click(TObject *Sender);
  void __fastcall BrowDestBtnClick(TObject *Sender);
  void __fastcall ZipperBtnClick(TObject *Sender);
  void __fastcall ShowRelDirClick(TObject *Sender);
  void __fastcall ZipAllBoxClick(TObject *Sender);
  void __fastcall ZipRelBoxClick(TObject *Sender);
  void __fastcall CompileBtnClick(TObject *Sender);
  void __fastcall ShowAppDirBtnClick(TObject *Sender);
  void __fastcall BrowseMakeBtnClick(TObject *Sender);
  void __fastcall BrowAspackBtnClick(TObject *Sender);
  void __fastcall BrowVersionHBtnClick(TObject *Sender);
  void __fastcall OpenVersionHBtnClick(TObject *Sender);
  void __fastcall VersionChange(TObject *Sender);
  void __fastcall OpenMakBtnClick(TObject *Sender);
  void __fastcall AppMakChange(TObject *Sender);
  void __fastcall Memo5DblClick(TObject *Sender);
  void __fastcall CopiedDblClick(TObject *Sender);
  void __fastcall Memo2DblClick(TObject *Sender);
  void __fastcall CompedDblClick(TObject *Sender);
  void __fastcall Memo3DblClick(TObject *Sender);
  void __fastcall CreateSEBtnClick(TObject *Sender);
  void __fastcall Memo1DblClick(TObject *Sender);
  void __fastcall SEinputBtnClick(TObject *Sender);
  void __fastcall SpeedButton1Click(TObject *Sender);
  void __fastcall Open1Click(TObject *Sender);
  void __fastcall FListBtnClick(TObject *Sender);
  void __fastcall SpeedButton2Click(TObject *Sender);
  void __fastcall HistoryBtnClick(TObject *Sender);
  void __fastcall ReadmeBtnClick(TObject *Sender);
  void __fastcall LicenseBtnClick(TObject *Sender);
  void __fastcall TodoBtnClick(TObject *Sender);
  void __fastcall QuickstartBtnClick(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
private:	// User declarations
public:		// User declarations
  int page,pages;
  __fastcall TIniForm(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern TIniForm *IniForm;
//---------------------------------------------------------------------------
#endif
