#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library BCBMM.LIB to both the DLL project and any
//   EXE projects that use the DLL.  This will change the DLL and its calling
//   EXE's to use the BCBMM.DLL as their memory manager.  In these cases,
//   the file BCBMM.DLL should be deployed along with your DLL.
//
//   To avoid using BCBMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//---------------------------------------------------------------------------
#include "popaccdlg.h"
#include "global.h"
#include "popretdlg.h"

USERES("QSPOP3.res");
USEFORM("PopAccDlg.cpp", PopAcctDlg);
USEFORM("PopProfDlg.cpp", AccProfDlg);
USEFORM("PopRetDlg.cpp", PopRetrDlg);
USEFORM("PopPassDlg.cpp", PassDlg);
USEUNIT("Global.cpp");
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall GetPop3Mail(TForm *MainForm,
   HWND AppHandle, bool UseDialog);

   //---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
void __fastcall GetPop3Mail(TForm *MainForm, HWND AppHandle, bool UseDialog)
{
   Application->Handle = AppHandle;
   if (!UseDialog)
   {
      TStringList *accts = new TStringList();
      accts->SetText((char*)MainForm->Perform(WM_DATREQUEST,GetDatData,(LPARAM)PopAccounts.c_str()));
      // use just the PopRetrDlg--remove unchecked from accts
      int i=0; while (i<accts->Count)
      {
         if (accts->Strings[i].LowerCase().Pos("checked=1")==0)
             accts->Delete(i); else i++;
      }
      if (accts->Count)
      {
         PopRetrieveMail(accts,MainForm,MainForm);
         delete accts;
         return;
      }
      delete accts;
   }
   // no active accounts, fall through if get here,
   PopAcctDlg = new TPopAcctDlg(MainForm);
   CenterDialog(PopAcctDlg,MainForm);
   PopAcctDlg->accts->SetText((char*)MainForm->Perform(WM_DATREQUEST,GetDatData,(LPARAM)PopAccounts.c_str()));
   PopAcctDlg->SyncAccts();
   PopAcctDlg->ShowModal();
   if (PopAcctDlg->ModalResult!=mrCancel)
   {
      // send revised account list back to main app
      PopAcctDlg->accts->Insert(0,PopAccounts);
      MainForm->Perform(WM_DATREQUEST,PutDatData,(LPARAM)PopAcctDlg->accts->Text.c_str());
   }
   delete PopAcctDlg;
}
//---------------------------------------------------------------------------
