//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SaveDlg.h"
#include "FileMan.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma link "OpenDlg"
#pragma resource "*.dfm"
TSaveForm *SaveForm;
//---------------------------------------------------------------------------
AnsiString __fastcall SaveMessage(TStrings *Message, AnsiString &Section, AnsiString CurName)
{
   AnsiString name;
   SaveForm = new TSaveForm(CurName,Application->MainForm);
   SaveForm->LookInBox->Clear();
   SaveForm->LookInBox->Items->Add(Section);
   SaveForm->LookInBox->ItemIndex = 0;
   SaveForm->mode = "Save ";
   SaveForm->ShowModal();
   if (SaveForm->ModalResult==mrOk)
   {
      name = SaveForm->Name->Text;
      PutAppData(Section+PS+name,Message);
   }
   delete SaveForm;
   return name;
}
//---------------------------------------------------------------------------
__fastcall TSaveForm::TSaveForm(TComponent* Owner)
   : TOpenForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TSaveForm::TSaveForm(AnsiString &CurName, TComponent* Owner)
   : TOpenForm(Owner)
{
   Name->Text = CurName;
   Name->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TSaveForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel) { Name->Clear(); return; }

   TStringList *msgs = new TStringList();
   GetAppData(msgs,DatSection());
   if (msgs->IndexOf(Name->Text)>=0)
   {
      AnsiString msgstr = "The message \"";
      if (DatSection()==UserNotes) msgstr = "The note \""; else
      if (DatSection()==UserTemplates) msgstr = "The Template \"";
      if (MsgBoxHwnd(Handle,msgstr+Name->Text+"\" already exists!\n\nOverwrite?",
         "Duplicate Name",MB_OKCANCEL)==IDCANCEL)
      {
         ActiveControl = Name;
         CanClose = false;
         Name->Clear();
         return;
      }
   }
   delete msgs;
}
//---------------------------------------------------------------------------